import{s as Dt,n as Gt,o as Jt}from"../chunks/scheduler.c59d9fbb.js";import{S as Kt,i as Qt,g as a,s as n,r as F,A as Vt,h as l,f as e,c as s,j as Ot,u as E,x as r,k as Rt,y as Wt,a as i,v as N,d as X,t as z,w as B}from"../chunks/index.a47918e3.js";import{H as Y}from"../chunks/Heading.604bc707.js";function Zt(wt){let o,D,O,G,p,J,u,_t='SetFit supports various contrastive pair sampling strategies in <a href="/docs/setfit/v1.0.2/en/reference/trainer#setfit.TrainingArguments">TrainingArguments</a>. In this conceptual guide, we will learn about the following four sampling strategies:',K,h,Ct="<li><code>&quot;oversampling&quot;</code> (the default)</li> <li><code>&quot;undersampling&quot;</code></li> <li><code>&quot;unique&quot;</code></li> <li><code>&quot;num_iterations&quot;</code></li>",Q,m,Lt='Consider first reading the <a href="../setfit">SetFit conceptual guide</a> for a background on contrastive learning and positive &amp; negative pairs.',V,g,W,v,bt="Throughout this conceptual guide, we will use to the following example scenario:",Z,f,qt="<li>3 classes: “happy”, “content”, and “sad”.</li> <li>20 total samples: 8 “happy”, 4 “content”, and 8 “sad” samples.</li>",tt,c,Ht="Considering that a sentence pair of <code>(X, Y)</code> and <code>(Y, X)</code> result in the same embedding distance/loss, we only want to consider one of those two cases. Furthermore, we don’t want pairs where both sentences are the same, e.g. no <code>(X, X)</code>.",dt,x,Mt="The resulting positive and negative pairs can be visualized in a table like below. The <code>+</code> and <code>-</code> represent positive and negative pairs, respectively. Furthermore, <code>h-n</code> represents the n-th “happy” sentence, <code>c-n</code> the n-th “content” sentence, and <code>s-n</code> the n-th “sad” sentence. Note that the area below the diagonal is not used as <code>(X, Y)</code> and <code>(Y, X)</code> result in the same embedding distances, and that the diagonal is not used as we are not interested in pairs where both sentences are identical.",et,y,Pt="<thead><tr><th></th> <th>h-1</th> <th>h-2</th> <th>h-3</th> <th>h-4</th> <th>h-5</th> <th>h-6</th> <th>h-7</th> <th>h-8</th> <th>c-1</th> <th>c-2</th> <th>c-3</th> <th>c-4</th> <th>s-1</th> <th>s-2</th> <th>s-3</th> <th>s-4</th> <th>s-5</th> <th>s-6</th> <th>s-7</th> <th>s-8</th></tr></thead> <tbody><tr><td><strong>h-1</strong></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>h-2</strong></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>h-3</strong></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>h-4</strong></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>h-5</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>h-6</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>h-7</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>h-8</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>c-1</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>c-2</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>c-3</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>c-4</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td> <td>-</td></tr> <tr><td><strong>s-1</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td></tr> <tr><td><strong>s-2</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td></tr> <tr><td><strong>s-3</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>+</td> <td>+</td></tr> <tr><td><strong>s-4</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td> <td>+</td></tr> <tr><td><strong>s-5</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td> <td>+</td></tr> <tr><td><strong>s-6</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td> <td>+</td></tr> <tr><td><strong>s-7</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td>+</td></tr> <tr><td><strong>s-8</strong></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td> <td></td></tr></tbody>",it,$,It="As shown in the prior table, we have 28 positive pairs for “happy”, 6 positive pairs for “content”, and another 28 positive pairs for “sad”. In total, this is 62 positive pairs. Also, we have 32 negative pairs between “happy” and “content”, 64 negative pairs between “happy” and “sad”, and 32 negative pairs between “content” and “sad”. In total, this is 128 negative pairs.",nt,T,st,w,St="By default, SetFit applies the oversampling strategy for its contrastive pairs. This strategy samples an equal amount of positive and negative training pairs, oversampling the minority pair type to match that of the majority pair type. As the number of negative pairs is generally larger than the number of positive pairs, this usually involves oversampling the positive pairs.",at,_,Ut="In our running example, this would involve oversampling the 62 positive pairs up to 128, resulting in one epoch of 128 + 128 = 256 pairs. In summary:",lt,C,At="<li>✅ An equal amount of positive and negative pairs are sampled.</li> <li>✅ Every possible pair is used.</li> <li>❌ There is some data duplication.</li>",rt,L,ot,b,jt="Like oversampling, this strategy samples an equal amount of positive and negative training pairs. However, it undersamples the majority pair type to match that of the minority pair type. This usually involves undersampling the negative pairs to match the positive pairs.",pt,q,kt="In our running example, this would involve undersampling the 128 negative pairs down to 62, resulting in one epoch of 62 + 62 = 124 pairs. In summary:",ut,H,Ft="<li>✅ An equal amount of positive and negative pairs are sampled.</li> <li>❌ <strong>Not</strong> every possible pair is used.</li> <li>✅ There is <strong>no</strong> data duplication.</li>",ht,M,mt,P,Et="Thirdly, the unique strategy does not sample an equal amount of positive and negative training pairs. Instead, it simply samples all possible pairs exactly once. No form of oversampling or undersampling is used here.",gt,I,Nt="In our running example, this would involve sampling all negative and positive pairs, resulting in one epoch of 62 + 128 = 190 pairs. In summary:",vt,S,Xt="<li>❌ <strong>Not</strong> an equal amount of positive and negative pairs are sampled.</li> <li>✅ Every possible pair is used.</li> <li>✅ There is <strong>no</strong> data duplication.</li>",ft,U,ct,A,zt="Lastly, SetFit can still be used with a deprecated sampling strategy involving the <code>num_iterations</code> training argument. Unlike the other sampling strategies, this strategy does not involve the number of possible pairs. Instead, it samples <code>num_iterations</code> positive pairs and <code>num_iterations</code> negative pairs for each training sample.",xt,j,Bt="In our running example, if we assume <code>num_iterations=20</code>, then we would sample 20 positive pairs and 20 negative pairs per training sample. Because there’s 20 samples, this involves (20 + 20) * 20 = 800 pairs. Because there are only 190 unique pairs, this certainly involves some data duplication. However, it does not guarantee that every possible pair is used. In summary:",yt,k,Yt="<li>✅ <strong>Not</strong> an equal amount of positive and negative pairs are sampled.</li> <li>❌ Not necessarily every possible pair is used.</li> <li>❌ There is some data duplication.</li>",$t,R,Tt;return p=new Y({props:{title:"SetFit Sampling Strategies",local:"setfit-sampling-strategies",headingTag:"h1"}}),g=new Y({props:{title:"Running example",local:"running-example",headingTag:"h2"}}),T=new Y({props:{title:"Oversampling",local:"oversampling",headingTag:"h2"}}),L=new Y({props:{title:"Undersampling",local:"undersampling",headingTag:"h2"}}),M=new Y({props:{title:"Unique",local:"unique",headingTag:"h2"}}),U=new Y({props:{title:"num_iterations",local:"numiterations",headingTag:"h2"}}),{c(){o=a("meta"),D=n(),O=a("p"),G=n(),F(p.$$.fragment),J=n(),u=a("p"),u.innerHTML=_t,K=n(),h=a("ol"),h.innerHTML=Ct,Q=n(),m=a("p"),m.innerHTML=Lt,V=n(),F(g.$$.fragment),W=n(),v=a("p"),v.textContent=bt,Z=n(),f=a("ul"),f.innerHTML=qt,tt=n(),c=a("p"),c.innerHTML=Ht,dt=n(),x=a("p"),x.innerHTML=Mt,et=n(),y=a("table"),y.innerHTML=Pt,it=n(),$=a("p"),$.textContent=It,nt=n(),F(T.$$.fragment),st=n(),w=a("p"),w.textContent=St,at=n(),_=a("p"),_.textContent=Ut,lt=n(),C=a("ul"),C.innerHTML=At,rt=n(),F(L.$$.fragment),ot=n(),b=a("p"),b.textContent=jt,pt=n(),q=a("p"),q.textContent=kt,ut=n(),H=a("ul"),H.innerHTML=Ft,ht=n(),F(M.$$.fragment),mt=n(),P=a("p"),P.textContent=Et,gt=n(),I=a("p"),I.textContent=Nt,vt=n(),S=a("ul"),S.innerHTML=Xt,ft=n(),F(U.$$.fragment),ct=n(),A=a("p"),A.innerHTML=zt,xt=n(),j=a("p"),j.innerHTML=Bt,yt=n(),k=a("ul"),k.innerHTML=Yt,$t=n(),R=a("p"),this.h()},l(t){const d=Vt("svelte-u9bgzb",document.head);o=l(d,"META",{name:!0,content:!0}),d.forEach(e),D=s(t),O=l(t,"P",{}),Ot(O).forEach(e),G=s(t),E(p.$$.fragment,t),J=s(t),u=l(t,"P",{"data-svelte-h":!0}),r(u)!=="svelte-g7bmkq"&&(u.innerHTML=_t),K=s(t),h=l(t,"OL",{"data-svelte-h":!0}),r(h)!=="svelte-1k1cxqz"&&(h.innerHTML=Ct),Q=s(t),m=l(t,"P",{"data-svelte-h":!0}),r(m)!=="svelte-ujlaed"&&(m.innerHTML=Lt),V=s(t),E(g.$$.fragment,t),W=s(t),v=l(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-1xsxa35"&&(v.textContent=bt),Z=s(t),f=l(t,"UL",{"data-svelte-h":!0}),r(f)!=="svelte-1ynee0z"&&(f.innerHTML=qt),tt=s(t),c=l(t,"P",{"data-svelte-h":!0}),r(c)!=="svelte-5u02v0"&&(c.innerHTML=Ht),dt=s(t),x=l(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1nrjj5a"&&(x.innerHTML=Mt),et=s(t),y=l(t,"TABLE",{"data-svelte-h":!0}),r(y)!=="svelte-usxqda"&&(y.innerHTML=Pt),it=s(t),$=l(t,"P",{"data-svelte-h":!0}),r($)!=="svelte-1bpfdiq"&&($.textContent=It),nt=s(t),E(T.$$.fragment,t),st=s(t),w=l(t,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1gpw2sh"&&(w.textContent=St),at=s(t),_=l(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1oeac4y"&&(_.textContent=Ut),lt=s(t),C=l(t,"UL",{"data-svelte-h":!0}),r(C)!=="svelte-1osxmr2"&&(C.innerHTML=At),rt=s(t),E(L.$$.fragment,t),ot=s(t),b=l(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-7ql780"&&(b.textContent=jt),pt=s(t),q=l(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-lgesbj"&&(q.textContent=kt),ut=s(t),H=l(t,"UL",{"data-svelte-h":!0}),r(H)!=="svelte-i8eycc"&&(H.innerHTML=Ft),ht=s(t),E(M.$$.fragment,t),mt=s(t),P=l(t,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1hjdd8p"&&(P.textContent=Et),gt=s(t),I=l(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-ydil1h"&&(I.textContent=Nt),vt=s(t),S=l(t,"UL",{"data-svelte-h":!0}),r(S)!=="svelte-10rld6m"&&(S.innerHTML=Xt),ft=s(t),E(U.$$.fragment,t),ct=s(t),A=l(t,"P",{"data-svelte-h":!0}),r(A)!=="svelte-cqiajv"&&(A.innerHTML=zt),xt=s(t),j=l(t,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1g4qf9q"&&(j.innerHTML=Bt),yt=s(t),k=l(t,"UL",{"data-svelte-h":!0}),r(k)!=="svelte-kw0ef6"&&(k.innerHTML=Yt),$t=s(t),R=l(t,"P",{}),Ot(R).forEach(e),this.h()},h(){Rt(o,"name","hf:doc:metadata"),Rt(o,"content",td)},m(t,d){Wt(document.head,o),i(t,D,d),i(t,O,d),i(t,G,d),N(p,t,d),i(t,J,d),i(t,u,d),i(t,K,d),i(t,h,d),i(t,Q,d),i(t,m,d),i(t,V,d),N(g,t,d),i(t,W,d),i(t,v,d),i(t,Z,d),i(t,f,d),i(t,tt,d),i(t,c,d),i(t,dt,d),i(t,x,d),i(t,et,d),i(t,y,d),i(t,it,d),i(t,$,d),i(t,nt,d),N(T,t,d),i(t,st,d),i(t,w,d),i(t,at,d),i(t,_,d),i(t,lt,d),i(t,C,d),i(t,rt,d),N(L,t,d),i(t,ot,d),i(t,b,d),i(t,pt,d),i(t,q,d),i(t,ut,d),i(t,H,d),i(t,ht,d),N(M,t,d),i(t,mt,d),i(t,P,d),i(t,gt,d),i(t,I,d),i(t,vt,d),i(t,S,d),i(t,ft,d),N(U,t,d),i(t,ct,d),i(t,A,d),i(t,xt,d),i(t,j,d),i(t,yt,d),i(t,k,d),i(t,$t,d),i(t,R,d),Tt=!0},p:Gt,i(t){Tt||(X(p.$$.fragment,t),X(g.$$.fragment,t),X(T.$$.fragment,t),X(L.$$.fragment,t),X(M.$$.fragment,t),X(U.$$.fragment,t),Tt=!0)},o(t){z(p.$$.fragment,t),z(g.$$.fragment,t),z(T.$$.fragment,t),z(L.$$.fragment,t),z(M.$$.fragment,t),z(U.$$.fragment,t),Tt=!1},d(t){t&&(e(D),e(O),e(G),e(J),e(u),e(K),e(h),e(Q),e(m),e(V),e(W),e(v),e(Z),e(f),e(tt),e(c),e(dt),e(x),e(et),e(y),e(it),e($),e(nt),e(st),e(w),e(at),e(_),e(lt),e(C),e(rt),e(ot),e(b),e(pt),e(q),e(ut),e(H),e(ht),e(mt),e(P),e(gt),e(I),e(vt),e(S),e(ft),e(ct),e(A),e(xt),e(j),e(yt),e(k),e($t),e(R)),e(o),B(p,t),B(g,t),B(T,t),B(L,t),B(M,t),B(U,t)}}}const td='{"title":"SetFit Sampling Strategies","local":"setfit-sampling-strategies","sections":[{"title":"Running example","local":"running-example","sections":[],"depth":2},{"title":"Oversampling","local":"oversampling","sections":[],"depth":2},{"title":"Undersampling","local":"undersampling","sections":[],"depth":2},{"title":"Unique","local":"unique","sections":[],"depth":2},{"title":"num_iterations","local":"numiterations","sections":[],"depth":2}],"depth":1}';function dd(wt){return Jt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class sd extends Kt{constructor(o){super(),Qt(this,o,dd,Zt,Dt,{})}}export{sd as component};
